
Ruby - Bug #9811

Numeric#step ignores `to` silently by keyword arguments.

05/07/2014 08:16 AM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee:    

Target version: 2.2.0   

ruby -v: r45860 Backport: 2.0.0: DONTNEED, 2.1: DONE

Description

Numeric#stepにキーワード引数を指定すると、終了値が無視されます。

無効なキーワードでもエラーになりません。

1.step(10, foo: nil)

Associated revisions

Revision a352b0a20744a19c2fcb2ea5af576805c0706aea - 05/07/2014 08:24 AM - nobu (Nobuyoshi Nakada)

numeric.c: check keyword arguments

numeric.c (num_step_scan_args): check keyword arguments and fail

if they conflict with positional arguments.

[ruby-dev:48177] [Bug #9811]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45861 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a352b0a2 - 05/07/2014 08:24 AM - nobu (Nobuyoshi Nakada)

numeric.c: check keyword arguments

numeric.c (num_step_scan_args): check keyword arguments and fail

if they conflict with positional arguments.

[ruby-dev:48177] [Bug #9811]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45861 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 71336a03fa72d7fb61159bc2add4001c1955c285 - 07/01/2014 02:36 PM - nagachika (Tomoyuki Chikanaga)

numeric.c (num_step_scan_args): table argument of rb_get_kwargs() is

array of IDs, not Symbols. [ruby-dev:48353] [Bug #9811]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46638 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 71336a03 - 07/01/2014 02:36 PM - nagachika (Tomoyuki Chikanaga)

numeric.c (num_step_scan_args): table argument of rb_get_kwargs() is

array of IDs, not Symbols. [ruby-dev:48353] [Bug #9811]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46638 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5ab69337816b10557e5a1658a5fa980c790a4b48 - 07/02/2014 04:27 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r45858,r45859,r45860,r45861,r46638: [Backport #9811]

    numeric.c: indent

    * numeric.c (ruby_num_interval_step_size): adjust indent.

    * numeric.c (num_step_scan_args): check keyword arguments and fail

      if they conflict with positional arguments.

      [ruby-dev:48177] [Bug #9811]

    * numeric.c (num_step_scan_args): table argument of rb_get_kwargs() is

      array of IDs, not Symbols. [ruby-dev:48353] [Bug #9811]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@46661 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 5ab69337 - 07/02/2014 04:27 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r45858,r45859,r45860,r45861,r46638: [Backport #9811]

    numeric.c: indent

    * numeric.c (ruby_num_interval_step_size): adjust indent.

    * numeric.c (num_step_scan_args): check keyword arguments and fail

      if they conflict with positional arguments.

      [ruby-dev:48177] [Bug #9811]

    * numeric.c (num_step_scan_args): table argument of rb_get_kwargs() is

      array of IDs, not Symbols. [ruby-dev:48353] [Bug #9811]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@46661 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/07/2014 08:24 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset r45861.

numeric.c: check keyword arguments

numeric.c (num_step_scan_args): check keyword arguments and fail

if they conflict with positional arguments.

[ruby-dev:48177] [Bug #9811]

#2 - 07/01/2014 02:34 PM - nagachika (Tomoyuki Chikanaga)

r45861 およびその準備の r45859, r45860 を ruby_2_1 にバックポートすると 1.step(by: 0).size が "in `size': unknown keywords: by, to (ArgumentError)"

のような例外を発生させます。

rb_get_kwargs() は ID の配列を受けとりますが、Symbol の配列を渡しているためでした。trunk では rb_id2sym() が Symbol をそのまま返すため発生していませんでした。

#3 - 07/02/2014 04:28 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: DONTNEED, 2.1: REQUIRED to 2.0.0: DONTNEED, 2.1: DONE

r45858, r45859, r45860, r45861 and r46638 were backported into ruby_2_1 branch at r46661.
